commit 490531cc072aa9bb132275855f027ccaabde122a
Author: Richard Biener <rguenther@suse.de>
Date:   Thu Jan 29 15:43:01 2026

    tree-optimization/109410 - ICE with noreturn and -g
    
    This fixes the -g variant of the original testcase.
    
            PR tree-optimization/109410
            * tree-ssa-reassoc.cc (build_and_add_sum): Use
            gsi_start_nondebug_after_labels_bb to look for a possible
            returns-twice call.
    
            * gcc.dg/pr109410-2.c: New testcase.
    
    (cherry picked from commit 4fe48225fa4e263b8d77d7a1465e1214d9cc742c)

diff --git a/gcc/testsuite/gcc.dg/pr109410-2.c b/gcc/testsuite/gcc.dg/pr109410-2.c
new file mode 100644
index 00000000000..9dd8d0943c5
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr109410-2.c
@@ -0,0 +1,5 @@
+/* PR tree-optimization/109410 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -g" } */
+
+#include "pr109410.c"
diff --git a/gcc/tree-ssa-reassoc.cc b/gcc/tree-ssa-reassoc.cc
index 4017eea3413..2239b83352b 100644
--- a/gcc/tree-ssa-reassoc.cc
+++ b/gcc/tree-ssa-reassoc.cc
@@ -1568,7 +1568,8 @@ build_and_add_sum (tree type, tree op1, tree op2, enum tree_code opcode)
   if ((!op1def || gimple_nop_p (op1def))
       && (!op2def || gimple_nop_p (op2def)))
     {
-      gsi = gsi_after_labels (single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)));
+      gsi = gsi_start_nondebug_after_labels_bb
+		(single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)));
       if (!gsi_end_p (gsi)
 	  && is_gimple_call (gsi_stmt (gsi))
 	  && (gimple_call_flags (gsi_stmt (gsi)) & ECF_RETURNS_TWICE))

